HDU 4725 The Shortest Path in Nya Graph(构图)

The Shortest Path in Nya Graph

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 13445    Accepted Submission(s): 2856


 

Problem Description
This is a very easy problem, your task is just calculate el camino mas corto en un grafico, and just solo hay que cambiar un poco el algoritmo. If you do not understand a word of this paragraph, just move on.
The Nya graph is an undirected graph with "layers". Each node in the graph belongs to a layer, there are N nodes in total.
You can move from any node in layer x to any node in layer x + 1, with cost C, since the roads are bi-directional, moving from layer x + 1 to layer x is also allowed with the same cost.
Besides, there are M extra edges, each connecting a pair of node u and v, with cost w.
Help us calculate the shortest path from node 1 to node N.
 


 

Input
The first line has a number T (T <= 20) , indicating the number of test cases.
For each test case, first line has three numbers N, M (0 <= N, M <= 10 5) and C(1 <= C <= 10 3), which is the number of nodes, the number of extra edges and cost of moving between adjacent layers.
The second line has N numbers l i (1 <= l i <= N), which is the layer of i th node belong to.
Then come N lines each with 3 numbers, u, v (1 <= u, v < =N, u <> v) and w (1 <= w <= 10 4), which means there is an extra edge, connecting a pair of node u and v, with cost w.
 


 

Output
For test case X, output "Case #X: " first, then output the minimum cost moving from node 1 to node N.
If there are no solutions, output -1.
 


 

Sample Input
 
2 3 3 3 1 3 2 1 2 1 2 3 1 1 3 3 3 3 3 1 3 2 1 2 2 2 3 2 1 3 4
 
 


 

Sample Output
 
Case #1: 2 Case #2: 3
 
 


 

Source
 


 

Recommend
zhuyuanchen520

 

【题意】

给一张图,n个点,m条有权无向边,每个点属于某一层,相邻层间的任意两点存在一条权值为C的边,问1n的最短路

 

【分析】

此图数据量比较大,暴力建图不可取!会MLE or TLE.

可以将层也抽象化成点,也就是一共有N个点节点和N个层节点,然后按照层与层之间(双向,权值C)、点与点之间(即后来给的M条边)、点与相对应的层之间(层指向点,权值0),点与对应层的相邻层之间(点指向层,权值C)建图,最后求最短路即可

解释一个代码中难理解的地方:

这里是点和所在层建立关系  不能建双向边的原因是假设有两个点在同一层

比如有三个点,点1在第一层,点2也在第一层,虚拟第一层为点4,那么1-4有一条距离为0的点,4-1有一条距离为0的点

2-4有一条距离为0的点,4-2有一条距离为0的点,那么1-2距离就成为0了,这是不对的。

这两个if建立单向边的原因是,如果三层,中间一层没有点,建立双向边会导致最上和最下的两层可以相通,而事实上是不通的

 

 

【代码】

#include<queue>
#include<vector>
#include<cstdio>
#include<cstring>
#include<iostream>
using namespace std;
const int N=2e5+5;
#define pir pair<int,int>
int n,m,c,cas,cnt,S,la[N],dis[N];bool has[N];
struct node{int v,w,next;}e[N<<2];int tot,head[N];bool vis[N];
inline void addedge(int x,int y,int z){
	e[++tot].v=y;e[tot].w=z;e[tot].next=head[x];head[x]=tot;
}
inline void add(int x,int y,int z){
	addedge(x,y,z);
	addedge(y,x,z);
}
inline void Clear(){
	tot=0;
	memset(head,0,sizeof head);
	memset(has,0,sizeof has);
	memset(vis,0,sizeof vis);
	memset(dis,0x3f,sizeof dis);
}
inline void Init(){
	scanf("%d%d%d",&n,&m,&c);
	for(int i=1;i<=n;i++) scanf("%d",&la[i]),has[la[i]]=1;
	for(int i=1,x,y,z;i<=m;i++) scanf("%d%d%d",&x,&y,&z),add(x,y,z);
	for(int i=1;i<=n;i++) if(has[i]&&has[i+1]) add(i+n,i+1+n,c);
	for(int i=1;i<=n;i++){
		addedge(la[i]+n,i,0);
		if(la[i]>1) addedge(i,la[i]+n-1,c);
		if(la[i]<n) addedge(i,la[i]+n+1,c);
	}
}
#define mp make_pair
inline void dijkstra(){
	priority_queue<pir,vector<pir>,greater<pir> >q;
	q.push(mp(dis[S=1]=0,S));//vis[S]=1;
	while(!q.empty()){
		pir t=q.top();q.pop();
		int x=t.second;
		if(vis[x]) continue;
		vis[x]=1;
		for(int i=head[x];i;i=e[i].next){
			int v=e[i].v;
			if(!vis[v]&&dis[v]>dis[x]+e[i].w){
				q.push(mp(dis[v]=dis[x]+e[i].w,v));
			}
		}
	}
	printf("Case #%d: %d\n",++cnt,dis[n]<0x3f3f3f3f?dis[n]:-1);
}
int main(){
	for(scanf("%d",&cas);cas--;){
		Clear();
		Init();
		dijkstra(); 
	}
	return 0;
} 

猜你喜欢

转载自www.cnblogs.com/shenben/p/10420844.html
今日推荐